#-----------------------------------------------------------------------
# File    : fimcmds.py
# Contents: accretion/frequent item set mining commands
# Author  : Christian Borgelt
# History : 2013.01.18 file created
#           2013.01.31 option 'invbxs' added to accretion
#-----------------------------------------------------------------------
from fim import apriori, accretion

#-----------------------------------------------------------------------

def get_cmds (target='c'):      # get dictionary of python functions
    stats = ['p','t','g','f']   # list of statistics
    coma  = [('target', target), ('supp',-2), ('zmin', 2),
             ('agg', 'n'), ('thresh', 1), ('mode', 'z'),
             ('report', 'a')]   # get the common arguments
    fim   = [('apr', apriori, [('prune',  0)] +coma),
             ('a-2', apriori, [('prune', -2)] +coma),
             ('a-3', apriori, [('prune', -3)] +coma),
             ('a+2', apriori, [('prune', +2)] +coma),
             ('a+3', apriori, [('prune', +3)] +coma)]
    cmds  = [('apr_x',          # collect fim commands
              (apriori, dict([('eval', 'x')] +coma)))] \
          + [(n+'_'+s, (c, dict(a +[('eval', s)])))
             for s in stats for n,c,a in fim]
    if target == 'm':           # if maximal item sets, add accretion
        coma  = [('supp', -2), ('zmin', 2), ('siglvl', 1),
                 ('mode', 'z'), ('report','a')]
        acc   = [('acc', accretion, [('maxext',  2)] +coma)]
        # acc += [('acx', accretion, [('maxext', -1)] +coma)]
        cmds += [(n+'_'+s, (c, dict(a +[('stat', s)])))
                 for s in stats for n,c,a in acc]
    return dict(cmds)           # collect the commands/search methods

#-----------------------------------------------------------------------
